#ifndef _S_MARSHALLSTREAM_H
#define _S_MARSHALLSTREAM_H

#include "sharedDefs.h"
class cS_Writer;

class MarshallStream 
{
public:
	friend class cS_Writer;
	MarshallStream(int transferSize, cS_Writer* writer);
	~MarshallStream();
	int WriteBytes(char* buf, int nbytes);

private:
	bool StartArgs(int opcode, int client=_ALL); // args to send with first buf
	bool StopArgs();			  

	// data members
	cS_Writer*	mWriter;
	int			mSize;
	int			mBufIndex;
	char*		mBuf;
	int			mOpcode;
	int			mClient;

protected:
};

#endif