#ifndef _S_DEMARSHALLSTREAM_H
#define _S_DEMARSHALLSTREAM_H

#include "sharedDefs.h"

class DeMarshallStream 
{

public:
	friend class cS_Reader;
	DeMarshallStream(int transferSize);
	~DeMarshallStream();
	int ReadBytes(char* buf, int nbytes);

private:
	bool Start(UpdateCommand *update); // The stream to work on.
	bool Stop();

	// data members
	int				mSize;
	int				mBufIndex;
	UpdateCommand  *mCurrentUpdate;

protected:
};

#endif