#ifndef __OBJECT_H
#define __OBJECT_H

// Garbage collector support
#include <gc_cpp.h>
#include <gc_alloc.h>
extern "C" {
#include "gc_priv.h"
}
// End Garbage collector support.

#include "MarshallStream.h"
#include "DeMarshallStream.h"

//Garbage collectable and marshallable generic object.
class Object : public gc
{
	public:
		// base class that all shared objects must come from.
		virtual OBJ_RETURN Marshall(MarshallStream* stream)=0;
		virtual OBJ_RETURN DeMarshall(DeMarshallStream* stream)=0; 
};

#endif