#ifndef __C_SHAREDDEFS_H
#define __C_SHAREDDEFS_H

#define cerr cout

// MTS
#define S_MTS	64

#define _ALL	-1

#define S_PING_TIMEOUT		5000 //in ms
#define S_READER_TIMEOUT	10000 //in ms

// Update commands.
typedef struct UpdateCommand
{
	int				opcode;
	char			buf[S_MTS];
	UpdateCommand  *next;
} UpdateCommand;

typedef void (*Callback)(void);

// map functions to integers,  Send ints to reader with AM.
#define SHARE_CONT_INSERT		 0
#define SHARE_CONT_DELETE		 1
#define	SHARE_CONT_CLEAR		 2 
#define SHARE_CONT_WRITER_GONE	 3
#define SHARE_CONT_NEWCONT		 4
#define SHARE_CONT_TRANSFER_DONE 5
#define SHARE_CONT_CONTINUE		 6
#define SHARE_CONT_PING			 7

// Maximum users
#define	S_MAX_NUM_WRITERS 256
#define S_MAX_NUM_READERS 256

// AM Message constants.
#define S_REGISTER_HANDLER					1
#define S_REGISTER_REPLY_HANDLER			2
#define S_UNREGISTER_HANDLER				3
#define S_UNREGISTER_REPLY_HANDLER			4
#define S_UPDATE_HANDLER					5
#define	S_UPDATE_REPLY_HANDLER				6
#define S_RETURN_FAIL						7
#define S_RETURN_SUCCESS					8 
#define S_RETURN_CONTAINER_HANDLER			9
#define S_RETURN_CONTAINER_REPLY_HANDLER	10
#define S_REGISTER_TIMEOUT					3000
#define S_TAG								614
#define S_WRITERMAP							1

#endif